//customSounds.cs	For engine sounds and any sound not native to BL
//otherSounds.cs	Regular sounds of a vehicle
//server.cs		Vehicle settings, speedcheck
//Support_objects.cs	Things relating to modifying of the actual train(audio+horn+moving)

exec("./customSounds.cs");

exec("./otherDB.cs");

//----------------------------------------------------------------------------

datablock WheeledVehicleData(Tubetrainvehicle)
{
    category = "Vehicles";
    displayName = " ";
    shapeFile = "./shapes/Tubetrain.dts";
    emap = true;
    minMountDist = 3;
   
    numMountPoints = 27;
    mountThread[0] = "sit";
	mountThread[1] = "root";
	mountThread[2] = "root";
	mountThread[3] = "root";
	mountThread[4] = "root";
	mountThread[5] = "root";
	mountThread[6] = "root";
	mountThread[7] = "root";
	mountThread[8] = "root";
	mountThread[9] = "root";
	mountThread[10] = "root";
	mountThread[11] = "root";
	mountThread[12] = "root";
	mountThread[13] = "root";
	mountThread[14] = "root";
	mountThread[15] = "root";
	mountThread[16] = "root";
	mountThread[17] = "root";
	mountThread[18] = "root";
	mountThread[19] = "root";
	mountThread[20] = "root";
	mountThread[21] = "root";
	mountThread[22] = "root";
	mountThread[23] = "root";
	mountThread[24] = "root";
	mountThread[25] = "root";
	mountThread[26] = "root";

    maxDamage = 200.00;
    destroyedLevel = 200.00;
    energyPerDamagePoint = 160;
    speedDamageScale = 1.04;
    collDamageThresholdVel = 20.0;
    collDamageMultiplier   = 0.02;

    massCenter = "0 0 0";
    //massBox = "2 5 1";

    maxSteeringAngle = 0;  // Maximum steering angle, should match animation
    integration = 4;           // Force integration time: TickSec/Rate
    //tireEmitter = TireEmitter; // All the tires use the same dust emitter

    // 3rd person camera settings
    cameraRoll = false;         // Roll the camera with the vehicle
    cameraMaxDist = 30;         // Far distance from vehicle
    cameraOffset = 30;        // Vertical offset from camera mount point
    cameraLag = 0.0;           // Velocity lag of camera
    cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
    cameraTilt = 0.8;
    collisionTol = 0.1;        // Collision distance tolerance
    contactTol = 0.1;

    useEyePoint = false;    

	defaultTire	= tankTire;
	defaultSpring	= tankSpring;

    numWheels = 4;

    // Rigid Body
    mass = 300;
    density = 5.0;
    drag = 1.6;
    bodyFriction = 0.6;
    bodyRestitution = 0.6;
    minImpactSpeed = 10;       // Impacts over this invoke the script callback
    softImpactSpeed = 10;      // Play SoftImpact Sound
    hardImpactSpeed = 15;      // Play HardImpact Sound
    groundImpactMinSpeed    = 10.0;

    // Engine
    engineTorque = 600;      // Engine power
    engineBrake = 100;        // Braking when throttle is 0
    brakeTorque = 1000;        // When brakes are applied
    maxWheelSpeed = 40;       // Engine scale by current speed / max speed

    rollForce        = 0;
    yawForce        = 0;
    pitchForce        = 1000;
    rotationalDrag        = 0.2;

    // Energy
    maxEnergy = 100;
    jetForce = 3000;
    minJetEnergy = 30;
    jetEnergyDrain = 2;

    splash = vehicleSplash;
    splashVelocity = 4.0;
    splashAngle = 67.0;
    splashFreqMod = 300.0;
    splashVelEpsilon = 0.60;
    bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
    mediumSplashSoundVelocity = 10.0;   
    hardSplashSoundVelocity = 20.0;   
    exitSplashSoundVelocity = 5.0;
        
    //mediumSplashSound = "";
    //hardSplashSound = "";
    //exitSplashSound = "";
    
    // Sounds
    //jetSound = ScoutThrustSound;
    //engineSound = idleSound;
    squealSound = squealSound;
    softImpactSound = slowImpactSound;
    hardImpactSound = fastImpactSound;
    //wheelImpactSound = slowImpactSound;

    //explosion = VehicleExplosion;
    justcollided = 0;

    uiName = "Tube train";
    rideable = true;
    lookUpLimit = 0.65;
    lookDownLimit = 0.45;

    paintable = true;
   
    damageEmitter[0] = VehicleBurnEmitter;
    damageEmitterOffset[0] = "0.0 0.0 0.0 ";
    damageLevelTolerance[0] = 0.99;

    damageEmitter[1] = VehicleBurnEmitter;
    damageEmitterOffset[1] = "0.0 0.0 0.0 ";
    damageLevelTolerance[1] = 1.0;

    numDmgEmitterAreas = 1;

    initialExplosionProjectile = jeepExplosionProjectile;
    initialExplosionOffset = 0;         //offset only uses a z value for now

    burnTime = 4000;

    finalExplosionProjectile = tankFinalExplosionProjectile;
    finalExplosionOffset = 0.5;          //offset only uses a z value for now


    minRunOverSpeed    = 0.1;   //how fast you need to be going to run someone over (do damage)
    runOverDamageScale = 20;     //when you run over someone, speed * runoverdamagescale = damage amt
    runOverPushScale   = 20;   //how hard a person you're running over gets pushed
};

function TubetrainvehicleSpeedCheck(%this, %obj)
{
 
    if(!isObject(%obj))
        return;
 
    %vehicle = %obj;
 
 
    %slot = 0; //Play the sound in the driver's spot
    %speed = vectorLen(%obj.getVelocity());
    if(!%vehicle.oldSpeed)
        %vehicle.oldSpeed = %speed;
 
    //Braking is not working currently
    if(%vehicle.oldSpeed)
    {
        if((%vehicle.oldSpeed - %speed) > 1) //Braking rate of speed in 500MS
            %applyBrakes = true;
 
        if((%vehicle.oldSpeed - %speed) < 1)
            %applyBrakes = false;
    }
 
    if(%speed < 0) //Keeps throwing random negative numbers when train is at dead stop
        %speed = 0;
 
    %vehicle.oldSpeed = %speed;
    commandtoclient(%vehicle.getControllingClient(),'bottomprint', mFloor(%speed * 2) @"<font:impact:25><color:FFFFFF> BPS", 1);
 
    //We use else if's so that it will find a true statement then skip the rest
    if(%speed < 2) {
        %vehicle.stopAudio(%slot);
        }
 
    else if(%speed < 10)
        %vehicle.playAudio(%slot, throttle0Sound);
 
    else if(%speed < 15)
        %vehicle.playAudio(%slot, throttle1Sound);
 
    else if(%speed < 30)
        %vehicle.playAudio(%slot, throttle2Sound);
 
    else if(%speed < 45)
        %vehicle.playAudio(%slot, throttle3Sound);
 
    else if(%speed < 60)
        %vehicle.playAudio(%slot, throttle4Sound);
 
    else if(%speed < 80)
        %vehicle.playAudio(%slot, throttle5Sound);
 
    else if(%speed < 90)
        %vehicle.playAudio(%slot, throttle6Sound);
 
 
 
    if(%applyBrakes)
        %vehicle.playAudio(1, squealSound);
    if(!%applyBrakes)
        %vehicle.stopAudio(1);
       
       
       
       
    // Correct Axis
   
    %fullPos = %vehicle.getPosition();
   
    %actualPos = getWord(%vehicle.getPosition(), %vehicle.axisOfCorrection);
    %dif = mAbs(%actualPos - %vehicle.AutoCorrectPos);
   
    if(%dif > 0.02)
    {
   
        // Make Correction
       
        if(%vehicle.axisOfCorrection == 0)
        {
            // Correcting the X axis
           
            %x = %vehicle.AutoCorrectPos;
            %y = getWord(%fullPos, 1);
            %z = getWord(%fullPos, 2);
           
            %vehicle.setTransform(%x SPC %y SPC %z SPC %obj.AutoCorrectRot);
        }
       
        if(%vehicle.axisOfCorrection == 1)
        {
            // Correcting the Y axis
           
            %x = getWord(%fullPos, 0);
            %y = %vehicle.AutoCorrectPos;
            %z = getWord(%fullPos, 2);
           
            %vehicle.setTransform(%x SPC %y SPC %z SPC %obj.AutoCorrectRot);
        }
    }
       
       
 
    schedule(500,0,"TubetrainvehicleSpeedCheck",%this,%obj);
}
 
function Tubetrainvehicle::onadd(%this, %obj)
{
 
    parent::onadd(%this,%obj);
    TubetrainvehicleSpeedCheck(%this, %obj);
   
    schedule(100,0,"TrainAutoCorrect_GetData",%this,%obj);
}
 
 
function axisToEuler(%axis)
{
    %angleOver2 = getWord(%axis,3) * 0.5;
    %angleOver2 = -%angleOver2;
    %sinThetaOver2 = mSin(%angleOver2);
    %cosThetaOver2 = mCos(%angleOver2);
    %q0 = %cosThetaOver2;
    %q1 = getWord(%axis,0) * %sinThetaOver2;
    %q2 = getWord(%axis,1) * %sinThetaOver2;
    %q3 = getWord(%axis,2) * %sinThetaOver2;
    %q0q0 = %q0 * %q0;
    %q1q2 = %q1 * %q2;
    %q0q3 = %q0 * %q3;
    %q1q3 = %q1 * %q3;
    %q0q2 = %q0 * %q2;
    %q2q2 = %q2 * %q2;
    %q2q3 = %q2 * %q3;
    %q0q1 = %q0 * %q1;
    %q3q3 = %q3 * %q3;
    %m13 = 2.0 * (%q1q3 - %q0q2);
    %m21 = 2.0 * (%q1q2 - %q0q3);
    %m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
    %m23 = 2.0 * (%q2q3 + %q0q1);
    %m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
    return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}
 
function TrainAutoCorrect_GetData(%this, %obj)
{
 
    %spawnBrick             = %obj.spawnBrick;
    %spawnBrickTransform    = %spawnBrick.getTransform();
    %spawnBrickRotation     = getWords(%spawnBrickTransform, 3, 6);
    %spawnBrickEuler        = axisToEuler(%spawnBrickRotation);
    %zRot                   = mFloor(mAbs(getWord(%spawnBrickEuler, 2)));
   
    if(%zRot == 90)
        %obj.axisOfCorrection = 1;
    else
        %obj.axisOfCorrection = 0;
       
       
    %obj.AutoCorrectRot = %spawnBrickRotation;
    %obj.AutoCorrectPos = getWord(%spawnBrickTransform, %obj.axisOfCorrection);
}
	
exec("./Support_objects.cs");